#ifndef CGI_ENGINE_H_
#define CGI_ENGINE_H_

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <iostream>
#include <unistd.h>

#include <string>
#include <vector>
//#include "CommonLib.h"
#include "QueryInfo.h"

#define _SCRIPT_START_TAG		"<?RTC"
#define _SCRIPT_END_TAG		"?>"
#define _VALUE_MARKER_START	'['
#define _VALUE_MARKER_END		']'

#define _DEFAULT_PAGE "./html/ModeSelect.html"
#define _CONTROL_MAIN_PAGE "./html/ControlMainMenu.html"
#define _MEETING_ROOM_PAGE "./html/NotReady.html"

typedef std::pair <std::string, std::string> string_pair;

enum{
	_RUN_MODE_DEFAULT	= 0,
	_RUN_MODE_SCRIPT,
	_RUN_MODE_GET_LOOP_RANGE,
	_RUN_MODE_LOOP
};

class CGI_Engine
{
public:
	CGI_Engine(QueryInfo *query)	{query_info = query;}
	~CGI_Engine()					{}
//	bool writeHTML(std::string pageName = "");
	bool writeHTML();

protected:
	virtual std::string	getHTMLFileName(std::string pageName, std::string command);
	virtual std::string	getMapData(std::string keyName);
	virtual bool		readDataFile();
	virtual bool		loopProc(std::string loopKey);
	virtual void		setNextRecordData();

	bool		writeLine();

private:
	std::string runScript(std::string script);

private:
	std::string					m_DefaultPage;
	std::vector<std::string>	loopList;

protected:
	QueryInfo	*query_info;
	std::map <std::string, std::string> htmlList;
};

#endif /*CGI_ENGINE_H_*/
