#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>

#include "Tools.h"
#include "FrontDesk.h"

#ifdef _DEBUG
extern FILE		*pDbgLog;
#endif

FrontDesk::FrontDesk(QueryInfo *query) : CGI_Engine(query)
{
	// 自身が管理するHTMLページのマップを作る
	htmlList.insert(string_pair("default", "./cgi-bin/FrontDesk.html"));
	htmlList.insert(string_pair("GoFront", "./cgi-bin/GoFrontDesk.html"));

	curVisitorData.insert(string_pair("VisitorID", ""));
	curVisitorData.insert(string_pair("Name", ""));
	curVisitorData.insert(string_pair("VisitDate", ""));
	curVisitorData.insert(string_pair("Purpose", ""));
	curVisitorData.insert(string_pair("LastVisitDate", ""));

	curVisitorData.insert(string_pair("AnswerString", ""));
	curVisitorData.insert(string_pair("ExtString", ""));
}

FrontDesk::~FrontDesk()
{
}

bool FrontDesk::readDataFile()
{
#ifdef _DEBUG
	fprintf(pDbgLog, "訪問者データ読み込み\n");
#endif
	// 訪問者情報の取得
	if(query_info->GetQueryPair("VisitorNumber").length() > 0){
		if(visitor_info.readData(query_info->GetQueryPair("VisitorNumber")))
		{
#ifdef _DEBUG
	fprintf(pDbgLog, "訪問者データ読み込み完了\n");
#endif
			curVisitorData["VisitorID"]		= visitor_info.m_VisitNumber;
			curVisitorData["Name"]			= visitor_info.m_Name;
			curVisitorData["VisitDate"]		= GetDateTimeStr(&(visitor_info.m_VisitTime));
//std::cout << visitor_info.m_VisitTime << std::endl;
			curVisitorData["Purpose"]		= visitor_info.m_Purpose;
			curVisitorData["LastVisitDate"]	= "";
		}
	}
	else{
		if(query_info->GetQueryPair("Answer") == "1"){
			curVisitorData["AnswerString"]	= "「受付許可」入力を受け付けました。";
			curVisitorData["ExtString"]		= "受付までお出迎えお願いいたします。";
		}
		else{
			curVisitorData["AnswerString"]	= "「受付拒否」入力を受け付けました。";
			curVisitorData["ExtString"]		= "";
		}
	}


	return true;
}

std::string FrontDesk::getMapData(std::string keyName)
{
#ifdef _DEBUG
	fprintf(pDbgLog, "マップデータ %s : %s\n", keyName.c_str(), curVisitorData[keyName].c_str());
#endif
	return curVisitorData[keyName];
}

std::string	FrontDesk::getHTMLFileName(std::string pageName, std::string command)
{
	std::string		result;
#if 0
	int				sendState;
	size_t			recvSize;

	if(command.compare("API") == 0){
	}
	if (pageName.compare("指示終了") == 0){
		/*
		 * ビットを立てることにする。
		 * +-+-+-+-+-+-+-+-+
		 * | | | | | | | | |
		 * +-+-+-+-+-+-+-+-+
		 *            | | +-> 受付可(1) / 不可(0)	// 1
		 *            | +---> 案内有(1) / 無し(0)	// 2
		 *            +-----> 給仕有(1) / 無し(0)	// 4
		 */

		request.dummy = 0;

		if(command.compare("受付許可") == 0){
			if(query_info->GetQueryPair("RunGuide").compare("案内あり") == 0){
				request.dummy = 3;
			}
			else{
				request.dummy = 1;
			}
			if(query_info->GetQueryPair("RunService").compare("給仕あり") == 0){
				request.dummy = request.dummy | 4;
			}
		}

		if(command.compare("受付不可") == 0){
			request.dummy = 2;
		}

		request.mID = SetAnswer;
		sendState = msg_send(&request, sizeof(request));
	}
#endif
	return htmlList[pageName];
}

bool FrontDesk::loopProc(std::string loopKey)
{
#if 0
	LandmarkData	curData;

	for(std::map<std::string, LandmarkData>::iterator it = list.begin(); it != list.end(); it++){
		curData = it->second;

		setCurData(curData);

		writeLine();
	}
#endif
	return true;
}

#if 0
bool FrontDesk::SendVisitorData()
{
	int				sendState;
	VisitorInfo		request;
	char			*endPos;

	if(isMsgQueue() == true){
		memset(&request, 0, sizeof(request));
		if(query_info->GetQueryPair("meaning").length())
			strcpy(request.meaning, query_info->GetQueryPair("meaning").c_str());
		if(query_info->GetQueryPair("name").length())
			strcpy(request.name, query_info->GetQueryPair("name").c_str());
		if(query_info->GetQueryPair("company").length())
			strcpy(request.company, query_info->GetQueryPair("company").c_str());
		if(query_info->GetQueryPair("personnel").length())
			strcpy(request.personnel, query_info->GetQueryPair("personnel").c_str());
		if(query_info->GetQueryPair("number").length())
			request.number = strtol(query_info->GetQueryPair("number").c_str(), &endPos, 10);
		request.mID = SetVisitorInfo;
#ifdef _DEBUG
	fprintf(pDbgLog, "メッセージID格納\n");
#endif
		sendState = msg_send(&request, sizeof(request));
#ifdef _DEBUG
	fprintf(pDbgLog, "メッセージ送信\n");
#endif
		cout << "Location: /rtcenter-demo/html/Contacting.html\n\n";
		return true;
	}
#ifdef _DEBUG
	fprintf(pDbgLog, "送信してません\n");
#endif
	cout << "" << endl;
	return false;
}
#endif
