#ifndef QUERYINFO_H_
#define QUERYINFO_H_

#include <map>
#include <string>

#define _BOUNDARY_STR	"boundary="
typedef std::pair <std::string, std::string> query_pair;

typedef struct _Range
{
	size_t	start;
	size_t	end;
} range_st;

typedef struct _TransFileData{
	unsigned char	*fileData;
	size_t			fileSize;
}trans_file_st;

class QueryInfo{
public:
	QueryInfo();
	~QueryInfo();

protected:

public:
	bool			IsQueryData()			{ return (query_data.size() > 0);		}
	std::string		GetFunctionName()		{ return GetFunction("Function");		}
	std::string		GetSubFunctionName()	{ return GetFunction("SubFunction");	}
	std::string		GetCommand()			{ return GetCommandMode("Command");		}
	std::string		GetMode()				{ return GetCommandMode("Mode");		}
	std::string 	GetQueryPair(std::string key);
	trans_file_st	GetTransFileData()	{ return trans_data;	}
	std::string		GetRemoteIP()			{ return remote_ip;		}

	void ParseQuery(std::string query_str);
	void ReadQueryData();

private:
	std::map <std::string, std::string> query_data;
	trans_file_st						trans_data;
	std::string							remote_ip;

private:
	std::string GetPostData();
	std::string DecordQuery(std::string query_str);
	void GetMultipartData(unsigned char *buf,int len);
	range_st GetPartRange(size_t start, char* boundary_data, unsigned char* buff, int max_len);

	std::string		GetFunction(std::string key);
	std::string		GetCommandMode(std::string key);

};

#endif /*QUERYINFO_H_*/
