// -*-C++-*-
/*!
 * @file  ControlTerminalSVC_impl.cpp
 * @brief Service implementation code of ControlTerminal.idl
 *
 */
#include <iostream>
#include "ControlTerminalSVC_impl.h"

/*
 * Example implementational code for IDL interface StateChange
 */
StateChangeSVC_impl::StateChangeSVC_impl()
{
  // Please add extra constructor code here.
}


StateChangeSVC_impl::~StateChangeSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Long StateChangeSVC_impl::SetState(CORBA::Long src_id, CORBA::Long state, const char* state_str)
{
	return pParent->SetTerminalState(src_id, state, state_str);
}

/*
 * Example implementational code for IDL interface StateChangeFromPA10
 */
StateChangeFromPA10SVC_impl::StateChangeFromPA10SVC_impl()
{
  // Please add extra constructor code here.
}


StateChangeFromPA10SVC_impl::~StateChangeFromPA10SVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Long StateChangeFromPA10SVC_impl::SetState(CORBA::Long state, const char* state_str)
{
  // Please insert your code here and remove the following warning pragma
	return pParent->SetTerminalState(4, state, state_str);
}



// End of example implementational code

/*
 * Example implementational code for IDL interface StateChangeFromRH
 */
StateChangeFromRHSVC_impl::StateChangeFromRHSVC_impl()
{
  // Please add extra constructor code here.
}


StateChangeFromRHSVC_impl::~StateChangeFromRHSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Long StateChangeFromRHSVC_impl::SetState(CORBA::Long state, const char* state_str)
{
	long result, status;
  // Please insert your code here and remove the following warning pragma
	status = state;
	if(((status & 0x0000FFFF) == 4) || ((status & 0x0000FFFF) == 5)){
		status = (status & 0xFFFF0000) | 0x00000001;
	}
	result = pParent->SetTerminalState(3, status, state_str);

	return result;
}


#if 0
// End of example implementational code

/*
 * Example implementational code for IDL interface StateChangeFromMeeting
 */
StateChangeFromMeetingSVC_impl::StateChangeFromMeetingSVC_impl()
{
  // Please add extra constructor code here.
}


StateChangeFromMeetingSVC_impl::~StateChangeFromMeetingSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Long StateChangeFromMeetingSVC_impl::SetState(CORBA::Long state, const char* state_str)
{
  // Please insert your code here and remove the following warning pragma
	return pParent->SetTerminalState(2, state, state_str);
}



// End of example implementational code

/*
 * Example implementational code for IDL interface StateChangeFromReceptionist
 */
StateChangeFromReceptionistSVC_impl::StateChangeFromReceptionistSVC_impl()
{
  // Please add extra constructor code here.
}


StateChangeFromReceptionistSVC_impl::~StateChangeFromReceptionistSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Long StateChangeFromReceptionistSVC_impl::SetState(CORBA::Long state, const char* state_str)
{
  // Please insert your code here and remove the following warning pragma
	return pParent->SetTerminalState(1, state, state_str);
}



// End of example implementational code

/*
 * Example implementational code for IDL interface ServiceChange
 */

ServiceChangeSVC_impl::ServiceChangeSVC_impl()
{
  // Please add extra constructor code here.
}


ServiceChangeSVC_impl::~ServiceChangeSVC_impl()
{
  // Please add extra destructor code here.
}

/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Long ServiceChangeSVC_impl::SetService(CORBA::Long src, CORBA::Long service)
{
	long	result;

	result = pParent->SetServiceState(src, service);
	return result;
}

#endif


// End of example implementational code



